//------------------------------------------------------------------------------------------------+
// Filename: applib.cpp
// Content : ֗ȋ@\
//------------------------------------------------------------------------------------------------+

#include<cstdlib>
#include<ctime>
#include<cmath>
#include<list>
#include"applib.h"

using namespace std;


// Name: Randomize() -----------------------------------------------------------------------------+
// 
//------------------------------------------------------------------------------------------------+
void Randomize(){

	srand((unsigned)time(NULL));
}


// Name: CheckInteger() --------------------------------------------------------------------------+
// 񂪐ȂtrueԂ
//------------------------------------------------------------------------------------------------+
bool CheckInteger( char *str ){

	for( int i=0; ('0' <= str[i] && str[i] <= '9') || (i==0 && (str[i]=='+'||str[i]=='-')); i++ ){

		if( str[i+1] == '\0' ) return true;
	}
	return false;
}


// Name: CheckDouble() ---------------------------------------------------------------------------+
// 񂪎ȂtrueԂ
//------------------------------------------------------------------------------------------------+
bool CheckDouble( char *str ){

	int i=0;
	for(; ('0' <= str[i] && str[i] <= '9') || (i==0 && (str[i]=='+'||str[i]=='-')); i++ ) if( str[i+1] == '\0' ) return false;
	if( str[i] != '.' ) return false;
	i++;
	for(; '0' <= str[i] && str[i] <= '9'; i++ ) if( str[i+1] == '\0' ) return true;
	return false;
}


// Name: CheckString() ---------------------------------------------------------------------------+
// 񂪐ȂtrueԂ
//------------------------------------------------------------------------------------------------+
bool CheckString( char *str ){

	for( int i=0; ' ' <= str[i] && str[i] < 256; i++ ) if( str[i+1] == '\0' ) return true;
	return false;
}


// Name: calcRegressionLine() --------------------------------------------------------------------+
//	cd_for_regressionLine ̃f[^A߂
//	@	cd_for_regressionLine	: A߂_QxN^
//	@	a, b, c					: ̃p[^ ax+by+c=0
//------------------------------------------------------------------------------------------------+
void calcRegressionLine(const vector<Coordinate> &cd_for_regression_line, double *a, double *b, double *c){

	double x, y;
	double Sxx = 0, Syy = 0, Sxy = 0, Sx = 0, Sy = 0;
	int n = cd_for_regression_line.size();
	for(int cdi = 0; cdi < n; ++ cdi){
		x = cd_for_regression_line.at(cdi).x, y = cd_for_regression_line.at(cdi).y;
		Sxx += x*x;	Syy += y*y; Sxy += x*y;
		Sx  += x;		Sy  += y;
	}
	double nSxy_SxSy = n*Sxy - Sx*Sy, nSxx_Sx2 = n*Sxx - Sx*Sx;
	double T = nSxy_SxSy / nSxx_Sx2;
	*b = ((nSxx_Sx2 == 0.0) ? 0.0 : 1.0 / sqrt(1 + T * T));
	*a = ((nSxx_Sx2 == 0.0) ? 1.0 : - T * *b);
	*c = - (Sx*(*a) + Sy*(*b)) / n;
}


/*********************************** Kz^NX ************************************/

// Name: Rand() ----------------------------------------------------------------------------------+
// {bNXE~[@pĐKz^̗𔭐
//------------------------------------------------------------------------------------------------+
double GausRand::Rand(){

	double r1, r2, z;

	r1 = (double)rand() / (double)RAND_MAX;
	r2 = (double)rand() / (double)RAND_MAX;

	z = sqrt( -2.0 * log( r1 )) * cos( 2.0 * M_PI * r2 );

	return mean + sigma * z;
}


/****************************************** WNX *******************************************/

// Name: operator == -----------------------------------------------------------------------------+
// W̔rs
//------------------------------------------------------------------------------------------------+
bool Coordinate::operator==( Coordinate c ){

	if( x == c.x && y == c.y ) return true;
	return false;
}

// Name: operator != -----------------------------------------------------------------------------+
// W̔rs
//------------------------------------------------------------------------------------------------+
bool Coordinate::operator!=( Coordinate c ){

	if( x != c.x || y != c.y ) return true;
	return false;
}


/**************************************** Vector2DNX *****************************************/

// Name: Length() --------------------------------------------------------------------------------+
// xNg̑傫ijvZĕԂ
//------------------------------------------------------------------------------------------------+
double Vector2D::Length(void){

	return ( sqrt( dx*dx + dy*dy ) );
}


// Name: Normalize() -----------------------------------------------------------------------------+
// xNg𐳋K
//------------------------------------------------------------------------------------------------+
void Vector2D::Normalize(void){

	double l = Length();

	if( l != 0.0 ){
		dx /= l;
		dy /= l;
	}
}


// Name: operator == -----------------------------------------------------------------------------+
// xNg̔rs
//------------------------------------------------------------------------------------------------+
bool Vector2D::operator==( Vector2D vec ){

	if( dx == vec.dx && dy == vec.dy ) return true;
	return false;
}


// Name: operator != -----------------------------------------------------------------------------+
// xNg̔rs
//------------------------------------------------------------------------------------------------+
bool Vector2D::operator!=( Vector2D vec ){

	if( dx != vec.dx || dy != vec.dy ) return true;
	return false;
}


// Name: operator += -----------------------------------------------------------------------------+
// xNg̉Zs
//------------------------------------------------------------------------------------------------+
Vector2D& Vector2D::operator +=(Vector2D vec){

	dx += vec.dx;
	dy += vec.dy;

	return *this;
}


// Name: operator -= -----------------------------------------------------------------------------+
// xNǧZs
//------------------------------------------------------------------------------------------------+
Vector2D& Vector2D::operator -=(Vector2D vec){

	dx -= vec.dx;
	dy -= vec.dy;

	return *this;
}


// Name: operator *= -----------------------------------------------------------------------------+
// xNg̃XJ[Ƃ̏Zs
//------------------------------------------------------------------------------------------------+
Vector2D& Vector2D::operator *=( double f ){

	dx *= f;
	dy *= f;

	return *this;
}


// Name: operator /= -----------------------------------------------------------------------------+
// xNg̃XJ[Ƃ̏Zs
//------------------------------------------------------------------------------------------------+
Vector2D& Vector2D::operator /=( double f ){

	dx /= f;
	dy /= f;

	return *this;
}


// Name: operator + ------------------------------------------------------------------------------+
// xNg̉Zs
//------------------------------------------------------------------------------------------------+
Vector2D Vector2D::operator +( Vector2D vec ){

	return  Vector2D( dx + vec.dx,  dy + vec.dy );
}


// Name: operator - ------------------------------------------------------------------------------+
// xNǧZs
//------------------------------------------------------------------------------------------------+
Vector2D Vector2D::operator -(Vector2D vec){

	return Vector2D( dx - vec.dx, dy - vec.dy );
}


// Name: operator * ------------------------------------------------------------------------------+
// xNg̃XJ[Ƃ̏Zs
//------------------------------------------------------------------------------------------------+
Vector2D Vector2D::operator *(double f){

	return Vector2D( dx*f,  dy*f );
}


// Name: operator / ------------------------------------------------------------------------------+
// xNg̃XJ[Ƃ̏Zs
//------------------------------------------------------------------------------------------------+
Vector2D Vector2D::operator /(double f){

	return Vector2D( dx/f,  dy/f );
}


// Name: operator - ------------------------------------------------------------------------------+
// }CiX̃xNg
//------------------------------------------------------------------------------------------------+
Vector2D Vector2D::operator -(){

	return Vector2D( -dx, -dy );
}


// Name: Naiseki() -------------------------------------------------------------------------------+
// xNg̓ρiXJ[ρjvZĕԂ
//------------------------------------------------------------------------------------------------+
double Vector2D::operator *(Vector2D vec){

	return ((dx * vec.dx) + (dy * vec.dy));
}



/****************************************** LineNX *******************************************/

// Name: Line() ----------------------------------------------------------------------------------+
// LNX̃RXgN^i2Wwj
//------------------------------------------------------------------------------------------------+
Line::Line( Coordinate from, Coordinate to ){

	x = from.x;
	y = from.y;
	dx = to.x - x;
	dy = to.y - y;
}


// Name: Reverse() -------------------------------------------------------------------------------+
// L𔽓]
//------------------------------------------------------------------------------------------------+
Line Line::Reverse(){

	*this = Line( x + dx, y + dy, -dx, -dy );

	return *this;
}


// Name: Inverse() -------------------------------------------------------------------------------+
// L𔽓]̂Ԃ
//------------------------------------------------------------------------------------------------+
Line Line::Inverse(){
	return Line( x + dx, y + dy, -dx, -dy );
}


// Name: Get_t() ---------------------------------------------------------------------------------+
// L{ΑΏې̉ƌ邩{ tvZ
// QlURLFhttp://hakuhin.jp/as/collision.html
//------------------------------------------------------------------------------------------------+
double Line::Get_t(Line l){

	// Ώۂ̃xNg̖@xNg߂
	Line normal;
	normal.x  = l.x;
	normal.y  = l.y;
	normal.dx = -l.dy;
	normal.dy = l.dx;

	// @xNg𐳋K
	normal.Normalize();

	// xNg{ΑΏۃxNg̉ƌ邩{ tvZ
	double d = - (normal.x * normal.dx + normal.y * normal.dy);
    double t = -(normal.dx * x + normal.dy * y + d) / (normal.dx * dx + normal.dy * dy);

	return t;
}



// Name: KreuzungUrteil() ------------------------------------------------------------------------+
// xNǧsAĂtrueԂB[_ŐڂĂ邾łĂB
// QlURLFhttp://hakuhin.jp/as/collision.html
//------------------------------------------------------------------------------------------------+
bool Line::KreuzungUrteil(Line l){
	
	// ̎_ŌĂȂfalseԂ
	double t = l.Get_t( *this );
	if( t < 0.0 || 1.0 < t ) return false;

	t = Get_t(l);

	// W(kx,ky)߂
	double kx = x + t * dx;
	double ky = y + t * dy;

	// p2̃xNgpӂ
	Vector2D a( kx - x, ky - y );
	Vector2D b( kx - ( x + dx ), ky - ( y + dy ) );

	// 2̃xNg̓ςɂČs
	if( a*b <= 0.0 ) return true;
	return false;
}



// Name: KreuzungUrteilX() -----------------------------------------------------------------------+
// xNǧsAĂtrueԂB[_ŐڂĂ邾ȂĂȂB
// QlURLFhttp://hakuhin.jp/as/collision.html
//------------------------------------------------------------------------------------------------+
/*bool Line::KreuzungUrteilX(Line l){
	
	// ̎_ŌĂȂfalseԂ
	double t = l.Get_t( *this );
	if( t <= 0.0 || 1.0 <= t ) return false;

	t = Get_t(l);

	// W(kx,ky)߂
	double kx = x + t * dx;
	double ky = y + t * dy;

	// p2̃xNgpӂ
	Vector2D a( kx - x, ky - y );
	Vector2D b( kx - ( x + dx ), ky - ( y + dy ) );

	// 2̃xNg̓ςɂČs
	if( a*b < 0.0 ) return true;
	return false;
}*/
// Name: KreuzungUrteilX() -----------------------------------------------------------------------+
// W p1,p2 ԐƍW p3,p4 ԐĂ邩𒲂ׂ
// AdȂĂꍇ(3_,4_꒼ɂ)AuĂȂvAƔ肵܂B
// Algorithm by http://www5d.biglobe.ne.jp/~tomoya03/shtml/algorithm/Intersection.htm
//-------------------------------------------------------------------------------------------------+
bool Line::KreuzungUrteilX(Line l){

	Coordinate p1 = *this;
	Coordinate p2 = (*this).Inverse();
	Coordinate p3 = l;
	Coordinate p4 = l.Inverse();

	if(((p1.x - p2.x) * (p3.y - p1.y) + (p1.y - p2.y) * (p1.x - p3.x)) *
	   ((p1.x - p2.x) * (p4.y - p1.y) + (p1.y - p2.y) * (p1.x - p4.x)) < 0.0 ){

        if(((p3.x - p4.x) * (p1.y - p3.y) + (p3.y - p4.y) * (p3.x - p1.x)) *
		   ((p3.x - p4.x) * (p2.y - p3.y) + (p3.y - p4.y) * (p3.x - p2.x)) < 0.0 ) return true;

	}
	return false;
}
	

// Name: Kreuzung() -------------------------------------------------------------------------------+
// Q̌WԂiQčlj
// QĂƂ͌Ȃ
//-------------------------------------------------------------------------------------------------+
Coordinate Line::Kreuzung( Line l ){

	double t = Get_t( l );
	return Coordinate( x + t * dx, y + t * dy );
}



// Name: operator == -----------------------------------------------------------------------------+
// L̔rs
//------------------------------------------------------------------------------------------------+
bool Line::operator==( Line l ){

	if( x == l.x && y == l.y && dx == l.dx && dy == l.dy ) return true;
	return false;
}

// Name: operator != -----------------------------------------------------------------------------+
// L̔rs
//------------------------------------------------------------------------------------------------+
bool Line::operator!=( Line l ){

	if( x != l.x || y != l.y || dx != l.dx || dy != l.dy ) return true;
	return false;
}

// Name: operator = ------------------------------------------------------------------------------+
// W̑s
//------------------------------------------------------------------------------------------------+
Line& Line::operator=( Coordinate c ){

	x = c.x;
	y = c.y;

	return *this;
}

// Name: operator = ------------------------------------------------------------------------------+
// xNg̑s
//------------------------------------------------------------------------------------------------+
Line& Line::operator=( Vector2D vec ){

	dx = vec.dx;
	dy = vec.dy;

	return *this;
}


// Name: PointToLine() ---------------------------------------------------------------------------+
// ŗ^ꂽW炱̐܂ł̍ŒZȂԂ
// rw肷ƁCvZ̐̒[wr̒l̓ɂ炷
//------------------------------------------------------------------------------------------------+
Line Line::PointToLine( double x, double y, double r ){

	Line line = *this;

	// ̗[rZ
	Vector2D v( line.dx, line.dy );
	v.Normalize();
	line = Line( line.x + r * v.dx, line.y + r * v.dy, line.dx - 2.0 * r * v.dx, line.dy - 2.0 * r * v.dy );

	// Wւ̍ŒZW(kx,ky)߂
	Line to_line( x, y, -line.dy, line.dx );
	double t  = to_line.Get_t( line );
	double kx = to_line.x + t * to_line.dx;
	double ky = to_line.y + t * to_line.dy;

	// Wォǂ𔻒肷邽߂2̐pӂ
	Line a, b;
	a.x  = line.x;
	a.y  = line.y;
	a.dx = kx - a.x;
	a.dy = ky - a.y;

	b.x  = line.x + line.dx;
	b.y  = line.y + line.dy;
	b.dx = kx - b.x;
	b.dy = ky - b.y;

	// Wm[hɑ݂Ƃ
	if( a*b < 0.0 ){

		to_line.dx = kx - to_line.x;
		to_line.dy = ky - to_line.y;
		return to_line;
	}

	//m[hɑ݂Ȃ̂ŁC߂ق̒[_ɑ΂xNg߂
	Line l1( x, y, line.x - x          , line.y - y           );
	Line l2( x, y, line.x - x + line.dx, line.y - y + line.dy );

	if( l1.Length() < l2.Length() ) return l1;
	return l2;
}


/***************************************** p`NX ******************************************/

// Name: Polygon() -------------------------------------------------------------------------------+
// RXgN^
//------------------------------------------------------------------------------------------------+
Polygon::Polygon( Vertexes vertex ){

	this->vertex = vertex;
	square = 0.0;
	convex = isConvex();

	if( convex ){

		square = CalcSquare( vertex );
		CalcInside();
	}
}

// Name: Common() --------------------------------------------------------------------------------+
// ʂ̒_Ԃ
//------------------------------------------------------------------------------------------------+
Vertexes Polygon::Common( Vertexes a ){

	Vertexes common;

	for( int i=0; i< (int)vertex.size(); i++ ){
		for( int j=0; j< (int)a.size(); j++ ) if( vertex[i] == a[j] ){

			common.push_back( a[j] );
			break;
		}
	}

	return common;
}


// Name: Integration() ---------------------------------------------------------------------------+
// ̑p`Ɠ Ԃl͐
//------------------------------------------------------------------------------------------------+
bool Polygon::Integration( Polygon p ){

	Vertexes common = Common( p );

	if( common.size() != 2 ) return false;

	Polygon integrated = Integration( p, common );

	*this = integrated;

	return true;
}


// Name: ConvexIntegration() ---------------------------------------------------------------------+
// ̑p`Ɠ Ԃl͐ オʌ^łȂΎs
//------------------------------------------------------------------------------------------------+
bool Polygon::ConvexIntegration( Polygon p ){

	if( !convex || !p.Convex() ) return false;

	Vertexes common = Common( p );

	if( common.size() != 2 ) return false;

	Polygon integrated = Integration( p, common );

	if( !integrated.isConvex() ) return false;

	*this = integrated;

	return true;
}


// Name: Inside() --------------------------------------------------------------------------------+
// wWp`ȂtrueԂ
// ʌ^łȂΌʂ𓾂Ȃ
//------------------------------------------------------------------------------------------------+
bool Polygon::InSide( double x, double y ){

	if( !convex ) return false;

	Line to_inside( x, y, inside.x - x, inside.y - y );

	Vertexes vert = vertex;
	vert.push_back( vertex.front() );

	for( int i=0; i< (int)vertex.size(); i++ ){

		double t = to_inside.Get_t( Line( vert[i], vert[i+1] ));
		if( 0.0 < t && t < 1.0 ) return false;
	}

	return true;
}


// Name: isConvex() ------------------------------------------------------------------------------+
// ʌ^ǂ̔
// QlFŊwԃQ[3Dw p.281
//------------------------------------------------------------------------------------------------+
bool Polygon::isConvex(){

	if( vertex.size() < 3 ) return false;

	Vertexes vert = vertex;
	vert.push_back( vertex[0] );
	vert.push_back( vertex[1] );

	double angleSum = 0.0f;

	// |S̎Ċe_̊pxv
	for( int i=1; i< (int)vert.size()-1; i++ ){

		// ӃxNg擾
		Line e1 = Line( vert[i], vert[i-1] );
		Line e2 = Line( vert[i], vert[i+1] );

		// K
		e1.Normalize();
		e2.Normalize();

		// ς𗘗pď̊pvZčv
		angleSum += acos( e1*e2 );
	}

	// ʂƉ肵ƂApx̘aɂȂ邩vZ
	double convexAngleSum = (double)((int)vertex.size()-2) * M_PI;

	// px̍vׂ菬Ήł
	// l̕sm̂߁A킸ɋe͈͂
	if( angleSum < convexAngleSum - (double)vertex.size() * 0.0001f ) return false;
	return true;
}


// Name: CalcSquare() ----------------------------------------------------------------------------+
// _񂩂ʐςvZ
// Op`ɕčċAIɖʐςvZ
//------------------------------------------------------------------------------------------------+
double Polygon::CalcSquare( Vertexes vert ){

	if( vert.size()  < 3 ) return 0.0;
	if( vert.size() == 3 ){

		// z=0ƂăxNg̊OςvZ
		double z = ( vert[1].x - vert[0].x ) * ( vert[2].y - vert[0].y )
			     - ( vert[1].y - vert[0].y ) * ( vert[2].x - vert[0].x );

		return sqrt( z*z ) / 2.0;
	}

	// Op`o
	Vertexes new_vert;
	new_vert.push_back( vert[0] );
	new_vert.push_back( vert[ vert.size()-1 ] );
	new_vert.push_back( vert[ vert.size()-2 ] );
	vert.pop_back();

	return CalcSquare( vert ) + CalcSquare( new_vert );
}


// Name: CalcInside() ----------------------------------------------------------------------------+
// WvZ
//------------------------------------------------------------------------------------------------+
void Polygon::CalcInside(){

	double x = 0.0, y = 0.0;

	for( int i=0; i< (int)vertex.size(); i++ ){

		x += vertex[i].x;
		y += vertex[i].y;
	}

	inside.x = x / (int)vertex.size();
	inside.y = y / (int)vertex.size();
}


// Name: Integration() ---------------------------------------------------------------------------+
// ̑p`Ɠp`Ԃ
//------------------------------------------------------------------------------------------------+
Polygon Polygon::Integration( Polygon p, Vertexes common ){

	if( common.size() != 2 ) return Polygon();

	// XgɓȂ
	list<Coordinate> p1, p2;
	for( int i=0; i< (int)vertex.size(); i++ ) p1.push_back( vertex[i] );
	for( int i=0; i< (int)p.Vertex().size(); i++ ) p2.push_back( p.Vertex()[i] );

	// ʂ̒_Ŏn܂Cʂ̒_ŏI悤Ƀ\[g
	while(1){
		if( p1.front() == common[0] || p1.front() == common[1] ) break;
		p1.push_back( p1.front() );
		p1.pop_front();
	}
	bool check = false;
	for( int j=0; j<2; j++ ) if( p1.back() == common[j] ) check = true;
	if( !check ){
		p1.push_back( p1.front() );
		p1.pop_front();
	}

	while(1){
		if( p2.front() == common[0] || p2.front() == common[1] ) break;
		p2.push_back( p2.front() );
		p2.pop_front();
	}
	check = false;
	for( int j=0; j<2; j++ ) if( p2.back() == common[j] ) check = true;
	if( !check ){
		p2.push_back( p1.front() );
		p2.pop_front();
	}

	// Q}[Wƈ悤ɕבւ
	if( p1.front() == p2.front() ){

		list<Coordinate> reverce;
		while( !p2.empty() ){

			reverce.push_back( p2.back() );
			p2.pop_back();
		}
		p2 = reverce;
	}

	// Q}[W
	p1.pop_back();
	p2.pop_back();
	p1.insert( p1.end(), p2.begin(), p2.end() );

	// vectorɓȂ
	Vertexes integrate;
	while( !p1.empty() ){

		integrate.push_back( p1.front() );
		p1.pop_front();
	}

	return Polygon( integrate );
}

