//------------------------------------------------------------------------------------------------+
// Filename: applib.h
// Content : ֗ȋ@\
//------------------------------------------------------------------------------------------------+
#ifndef __APPLIB
#define __APPLIB

#include <vector>


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#ifndef M_PI
#define M_PI      3.14159265358979323846
#endif
#ifndef NULL
#define NULL      0
#endif


//------------------------------------------------------------------------------------------------+
// 萔̒`
//------------------------------------------------------------------------------------------------+
const double rad_to_deg = 180.0 / 3.14159265358979323846;
const double deg_to_rad = 3.14159265358979323846 / 180.0;


//------------------------------------------------------------------------------------------------+
// ֐̑O錾
//------------------------------------------------------------------------------------------------+
void Randomize(void);								// 
bool CheckInteger( char *str );						// 񂪐ȂtrueԂ
bool CheckDouble( char *str );						// 񂪎ȂtrueԂ
bool CheckString( char *str );						// 񂪐ȂtrueԂ


// Name: Abs() -----------------------------------------------------------------------------------+
// ΒlvZ
//------------------------------------------------------------------------------------------------+
template <typename T> inline T Abs( T x ){

	return ( ( 0 <= x )? x: -x );
}


//------------------------------------------------------------------------------------------------+
// Kz^̗𐶐NX
//------------------------------------------------------------------------------------------------+
class GausRand{
public:
	double mean, sigma;		// ςƕW΍

	GausRand(){}
	GausRand( double mean, double sigma ){ this->mean = mean; this->sigma = sigma; }

	double Rand();			// Kz^̗Ԃ
};


//------------------------------------------------------------------------------------------------+
// 2WNX̒`
//------------------------------------------------------------------------------------------------+
class Coordinate{
public:
	double x, y;

	Coordinate(){ x = y = 0.0; }
	Coordinate( double x, double y ){ this->x = x;  this->y = y; }

	bool operator==( Coordinate c );
	bool operator!=( Coordinate c );
};


//------------------------------------------------------------------------------------------------+
// ֐̑O錾̂Q
//------------------------------------------------------------------------------------------------+
void calcRegressionLine(const std::vector<Coordinate> &cd_for_regression_line, double *a, double *b, double *c);


//------------------------------------------------------------------------------------------------+
// 2xNgNX̒`
//------------------------------------------------------------------------------------------------+
class Vector2D{
public:
	double dx, dy;

	Vector2D(){ dx = dy = 0.0; }
	Vector2D( double dx, double dy ){ this->dx = dx; this->dy = dy; }

	double Length();						// xNg̑傫Ԃ
	void Normalize();						// xNg𐳋K

	bool operator==( Vector2D vec );
	bool operator!=( Vector2D vec );
	Vector2D& operator+=( Vector2D vec );
	Vector2D& operator-=( Vector2D vec );
	Vector2D& operator*=( double f );
	Vector2D& operator/=( double f );
	Vector2D operator+( Vector2D vec );
	Vector2D operator-( Vector2D vec );
	Vector2D operator*( double f );
	Vector2D operator/( double f );
	Vector2D operator-();
	double operator*( Vector2D vec );		// xNg̓ςԂ
};


//------------------------------------------------------------------------------------------------+
// LNX̒`
// ʒuƃxNgɂĒ`
//------------------------------------------------------------------------------------------------+
class Line :public Vector2D, public Coordinate{
public:
	Line(){ x = y = dx = dy = 0.0; }
	Line( double x, double y, double dx, double dy ):Coordinate(x,y), Vector2D(dx,dy){}
	Line( Coordinate c, Vector2D vec ){ x=c.x; y=c.y; dx=vec.dx; dy=vec.dy; }
	Line( Coordinate from, Coordinate to );

	Line Reverse();						// L𔽓]
	Line Inverse();						// L𔽓]̂Ԃ
	double Get_t( Line l );				// L{ΑΏې̉ƌ邩{ tvZ
	bool KreuzungUrteil( Line l );		// LĂtrueԂi[_Őڂ̂܂ށj
	bool KreuzungUrteilX( Line l );		// LĂtrueԂi[_Őڂ̂܂܂Ȃj
	Coordinate Kreuzung( Line l );		// Q̌WԂiQčlj

	bool operator==( Line l );
	bool operator!=( Line l );
	Line& operator=( Coordinate c );
	Line& operator=( Vector2D vec );

	Line PointToLine( double x, double y, double r = 0.0 );				// WƐƂ̍ŒZ߂
	Line PointToLine( Coordinate c, double r = 0.0 ){ return PointToLine( c.x, c.y, r ); }

	double CenterX(){ return( x + 0.5 * dx ); }							// XWԂ
	double CenterY(){ return( y + 0.5 * dy ); }							// YWԂ
	Coordinate Center(){ return Coordinate( CenterX(), CenterY() ); }	// ̍WԂ
};


//------------------------------------------------------------------------------------------------+
// _f[^n̒`
//------------------------------------------------------------------------------------------------+
typedef Coordinate Vertex;
typedef std::vector<Vertex> Vertexes;


//------------------------------------------------------------------------------------------------+
// p`NX̒`
//------------------------------------------------------------------------------------------------+
class Polygon{

protected:
	Vertexes vertex;		// _f[^
	bool convex;			// ʌ^ǂ
	Coordinate inside;		// Wiʌ^p`̂݌vZj
	double square;			// ʐρiʌ^p`̂݌vZj

public:
	Polygon(){ convex = false; square = 0.0; }
	Polygon( Vertexes vertex );

	bool Convex(){ return convex; }			// ʌ^ǂԂ
	Vertexes Vertex(){ return vertex; }		// _f[^Ԃ
	Vertexes Common( Vertexes a );			// ʂ̒_Ԃ
	bool Integration( Polygon p );			// ̑p`Ɠ Ԃl͐
	bool ConvexIntegration( Polygon p );	// ̑p`Ɠ Ԃl͐ オʌ^łȂΎs

	double Square(){ return square; }		// iʌ^̑p`̂݁jʐςԂ
	bool InSide( double x, double y );		// wWp`ȂtrueԂ(ʌ^łȂΌʂ𓾂Ȃ)

	Vertexes Common( Polygon p ){ return Common( p.Vertex()); }		// ʂ̒_Ԃ
	bool InSide( Coordinate c ){ return InSide( c.x, c.y ); }		// wWp`ȂtrueԂ(ʌ^łȂΌʂ𓾂Ȃ)

private:
	bool isConvex();						// ʌ^ǂ̔
	double CalcSquare( Vertexes vert );		// _񂩂ʐςvZ
	void CalcInside();						// WvZ
	Polygon Integration( Polygon p, Vertexes common );				// ̑p`Ɠp`Ԃ
};


//------------------------------------------------------------------------------------------------+
// L⑽p`̕ʖƌn`
//------------------------------------------------------------------------------------------------+
typedef class Line Segment;						// L̕ʖ
typedef std::vector<Line> Lines;				// Ľn
typedef std::vector<Segment> Segments;			// Ľnʖ
typedef class Polygon Vieleck;					// p`̕ʖ
typedef std::vector<class Polygon> Polygons;	// p`̌n
typedef std::vector<Vieleck> Vielecke;			// p`̌nʖ


#endif	//__APPLIB
